io.vertx.rxjava.core.file

## Class AsyncFile

- java.lang.Object
- - io.vertx.rxjava.core.file.AsyncFile

- All Implemented Interfaces:
    ReadStream<Buffer>, StreamBase, WriteStream<Buffer>

      public class AsyncFile
      extends Object
      implements ReadStream<Buffer>, WriteStream<Buffer>

  Represents a file on the file-system which can be read from, or written to asynchronously.

  This class also implements `ReadStream` and `WriteStream`. This allows the data to be pumped to and from other streams, e.g. an `HttpClientRequest` instance, using the `Pump` class

  NOTE: This class has been automatically generated from the `original` non RX-ified interface using Vert.x codegen.

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `AsyncFile(AsyncFile delegate)`

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `close()` Close the file.
    `void` | `close(Handler<AsyncResult<Void>> handler)` Close the file.
    `Observable<Void>` | `closeObservable()` Close the file.
    `AsyncFile` | `drainHandler(Handler<Void> handler)` Set a drain handler on the stream.
    `void` | `end()` Close the file, see `close()`.
    `void` | `end(Buffer t)` Same as `end(io.vertx.rxjava.core.buffer.Buffer)` but writes some data to the stream before ending.
    `AsyncFile` | `endHandler(Handler<Void> endHandler)` Set an end handler.
    `AsyncFile` | `exceptionHandler(Handler<Throwable> handler)` Set an exception handler on the read stream.
    `AsyncFile` | `flush()` Flush any writes made to this file to underlying persistent storage.
    `AsyncFile` | `flush(Handler<AsyncResult<Void>> handler)` Same as `flush()` but the handler will be called when the flush is complete or if an error occurs
    `Observable<Void>` | `flushObservable()` Same as `flush()` but the handler will be called when the flush is complete or if an error occurs
    `Object` | `getDelegate()`
    `AsyncFile` | `handler(Handler<Buffer> handler)` Set a data handler.
    `static AsyncFile` | `newInstance(AsyncFile arg)`
    `AsyncFile` | `pause()` Pause the `ReadSupport`.
    `AsyncFile` | `read(Buffer buffer, int offset, long position, int length, Handler<AsyncResult<Buffer>> handler)` Reads `length` bytes of data from the file at position `position` in the file, asynchronously.
    `Observable<Buffer>` | `readObservable(Buffer buffer, int offset, long position, int length)` Reads `length` bytes of data from the file at position `position` in the file, asynchronously.
    `AsyncFile` | `resume()` Resume reading.
    `AsyncFile` | `setReadBufferSize(int readBufferSize)` Sets the buffer size that will be used to read the data from the file.
    `AsyncFile` | `setReadPos(long readPos)` Sets the position from which data will be read from when using the file as a `ReadStream`.
    `AsyncFile` | `setWritePos(long writePos)` Sets the position from which data will be written when using the file as a `WriteStream`.
    `AsyncFile` | `setWriteQueueMaxSize(int maxSize)` Set the maximum size of the write queue to `maxSize`.
    `Observable<Buffer>` | `toObservable()`
    `AsyncFile` | `write(Buffer data)` Write some data to the stream.
    `AsyncFile` | `write(Buffer buffer, long position, Handler<AsyncResult<Void>> handler)` Write a `Buffer` to the file at position `position` in the file, asynchronously.
    `Observable<Void>` | `writeObservable(Buffer buffer, long position)` Write a `Buffer` to the file at position `position` in the file, asynchronously.
    `boolean` | `writeQueueFull()` This will return `true` if there are more bytes in the write queue than the value set using `setWriteQueueMaxSize(int)`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface io.vertx.rxjava.core.streams.ReadStream

      `newInstance`

    - ### Methods inherited from interface io.vertx.rxjava.core.streams.WriteStream

      `newInstance`

    - ### Methods inherited from interface io.vertx.rxjava.core.streams.StreamBase

      `newInstance`

- - ### Constructor Detail

    - #### AsyncFile

          public AsyncFile(AsyncFile delegate)

  - ### Method Detail

    - #### getDelegate

          public Object getDelegate()

      Specified by:
        `getDelegate` in interface `ReadStream<Buffer>`
      Specified by:
        `getDelegate` in interface `StreamBase`
      Specified by:
        `getDelegate` in interface `WriteStream<Buffer>`

    - #### toObservable

          public Observable<Buffer> toObservable()

      Specified by:
        `toObservable` in interface `ReadStream<Buffer>`

    - #### end

          public void end(Buffer t)

      Same as `end(io.vertx.rxjava.core.buffer.Buffer)` but writes some data to the stream before ending.
      Specified by:
        `end` in interface `WriteStream<Buffer>`
      Parameters:
        `t` -

    - #### writeQueueFull

          public boolean writeQueueFull()

      This will return `true` if there are more bytes in the write queue than the value set using `setWriteQueueMaxSize(int)`
      Specified by:
        `writeQueueFull` in interface `WriteStream<Buffer>`
      Returns:
        true if write queue is full

    - #### handler

          public AsyncFile handler(Handler<Buffer> handler)

      Description copied from interface: `ReadStream`
      Set a data handler. As data is read, the handler will be called with the data.
      Specified by:
        `handler` in interface `ReadStream<Buffer>`
      Returns:
        a reference to this, so the API can be used fluently

    - #### pause

          public AsyncFile pause()

      Description copied from interface: `ReadStream`
      Pause the `ReadSupport`. While it's paused, no data will be sent to the `dataHandler`
      Specified by:
        `pause` in interface `ReadStream<Buffer>`
      Returns:
        a reference to this, so the API can be used fluently

    - #### resume

          public AsyncFile resume()

      Description copied from interface: `ReadStream`
      Resume reading. If the `ReadSupport` has been paused, reading will recommence on it.
      Specified by:
        `resume` in interface `ReadStream<Buffer>`
      Returns:
        a reference to this, so the API can be used fluently

    - #### endHandler

          public AsyncFile endHandler(Handler<Void> endHandler)

      Description copied from interface: `ReadStream`
      Set an end handler. Once the stream has ended, and there is no more data to be read, this handler will be called.
      Specified by:
        `endHandler` in interface `ReadStream<Buffer>`
      Returns:
        a reference to this, so the API can be used fluently

    - #### write

          public AsyncFile write(Buffer data)

      Description copied from interface: `WriteStream`
      Write some data to the stream. The data is put on an internal write queue, and the write actually happens asynchronously. To avoid running out of memory by putting too much on the write queue, check the `WriteStream.writeQueueFull()` method before writing. This is done automatically if using a `Pump`.
      Specified by:
        `write` in interface `WriteStream<Buffer>`
      Parameters:
        `data` - the data to write
      Returns:
        a reference to this, so the API can be used fluently

    - #### setWriteQueueMaxSize

          public AsyncFile setWriteQueueMaxSize(int maxSize)

      Description copied from interface: `WriteStream`
      Set the maximum size of the write queue to `maxSize`. You will still be able to write to the stream even if there is more than `maxSize` bytes in the write queue. This is used as an indicator by classes such as `Pump` to provide flow control.
      Specified by:
        `setWriteQueueMaxSize` in interface `WriteStream<Buffer>`
      Parameters:
        `maxSize` - the max size of the write stream
      Returns:
        a reference to this, so the API can be used fluently

    - #### drainHandler

          public AsyncFile drainHandler(Handler<Void> handler)

      Description copied from interface: `WriteStream`
      Set a drain handler on the stream. If the write queue is full, then the handler will be called when the write queue has been reduced to maxSize / 2. See `Pump` for an example of this being used.
      Specified by:
        `drainHandler` in interface `WriteStream<Buffer>`
      Parameters:
        `handler` - the handler
      Returns:
        a reference to this, so the API can be used fluently

    - #### exceptionHandler

          public AsyncFile exceptionHandler(Handler<Throwable> handler)

      Description copied from interface: `ReadStream`
      Set an exception handler on the read stream.
      Specified by:
        `exceptionHandler` in interface `ReadStream<Buffer>`
      Specified by:
        `exceptionHandler` in interface `StreamBase`
      Specified by:
        `exceptionHandler` in interface `WriteStream<Buffer>`
      Parameters:
        `handler` - the exception handler
      Returns:
        a reference to this, so the API can be used fluently

    - #### end

          public void end()

      Close the file, see `close()`.
      Specified by:
        `end` in interface `WriteStream<Buffer>`

    - #### close

          public void close()

      Close the file. The actual close happens asynchronously.

    - #### close

          public void close(Handler<AsyncResult<Void>> handler)

      Close the file. The actual close happens asynchronously. The handler will be called when the close is complete, or an error occurs.
      Parameters:
        `handler` - the handler

    - #### closeObservable

          public Observable<Void> closeObservable()

      Close the file. The actual close happens asynchronously. The handler will be called when the close is complete, or an error occurs.
      Returns:

    - #### write

          public AsyncFile write(Buffer buffer,
                                 long position,
                                 Handler<AsyncResult<Void>> handler)

      Write a `Buffer` to the file at position `position` in the file, asynchronously.

      If `position` lies outside of the current size of the file, the file will be enlarged to encompass it.

      When multiple writes are invoked on the same file there are no guarantees as to order in which those writes actually occur

      The handler will be called when the write is complete, or if an error occurs.

      Parameters:
        `buffer` - the buffer to write
        `position` - the position in the file to write it at
        `handler` - the handler to call when the write is complete
      Returns:
        a reference to this, so the API can be used fluently

    - #### writeObservable

          public Observable<Void> writeObservable(Buffer buffer,
                                                  long position)

      Write a `Buffer` to the file at position `position` in the file, asynchronously.

      If `position` lies outside of the current size of the file, the file will be enlarged to encompass it.

      When multiple writes are invoked on the same file there are no guarantees as to order in which those writes actually occur

      The handler will be called when the write is complete, or if an error occurs.

      Parameters:
        `buffer` - the buffer to write
        `position` - the position in the file to write it at
      Returns:

    - #### read

          public AsyncFile read(Buffer buffer,
                                int offset,
                                long position,
                                int length,
                                Handler<AsyncResult<Buffer>> handler)

      Reads `length` bytes of data from the file at position `position` in the file, asynchronously.

      The read data will be written into the specified `Buffer buffer` at position `offset`.

      If data is read past the end of the file then zero bytes will be read.

      When multiple reads are invoked on the same file there are no guarantees as to order in which those reads actually occur.

      The handler will be called when the close is complete, or if an error occurs.

      Parameters:
        `buffer` - the buffer to read into
        `offset` - the offset into the buffer where the data will be read
        `position` - the position in the file where to start reading
        `length` - the number of bytes to read
        `handler` - the handler to call when the write is complete
      Returns:
        a reference to this, so the API can be used fluently

    - #### readObservable

          public Observable<Buffer> readObservable(Buffer buffer,
                                                   int offset,
                                                   long position,
                                                   int length)

      Reads `length` bytes of data from the file at position `position` in the file, asynchronously.

      The read data will be written into the specified `Buffer buffer` at position `offset`.

      If data is read past the end of the file then zero bytes will be read.

      When multiple reads are invoked on the same file there are no guarantees as to order in which those reads actually occur.

      The handler will be called when the close is complete, or if an error occurs.

      Parameters:
        `buffer` - the buffer to read into
        `offset` - the offset into the buffer where the data will be read
        `position` - the position in the file where to start reading
        `length` - the number of bytes to read
      Returns:

    - #### flush

          public AsyncFile flush()

      Flush any writes made to this file to underlying persistent storage.

      If the file was opened with `flush` set to `true` then calling this method will have no effect.

      The actual flush will happen asynchronously.

      Returns:
        a reference to this, so the API can be used fluently

    - #### flush

          public AsyncFile flush(Handler<AsyncResult<Void>> handler)

      Same as `flush()` but the handler will be called when the flush is complete or if an error occurs
      Parameters:
        `handler` -
      Returns:

    - #### flushObservable

          public Observable<Void> flushObservable()

      Same as `flush()` but the handler will be called when the flush is complete or if an error occurs
      Returns:

    - #### setReadPos

          public AsyncFile setReadPos(long readPos)

      Sets the position from which data will be read from when using the file as a `ReadStream`.
      Parameters:
        `readPos` - the position in the file
      Returns:
        a reference to this, so the API can be used fluently

    - #### setWritePos

          public AsyncFile setWritePos(long writePos)

      Sets the position from which data will be written when using the file as a `WriteStream`.
      Parameters:
        `writePos` - the position in the file
      Returns:
        a reference to this, so the API can be used fluently

    - #### setReadBufferSize

          public AsyncFile setReadBufferSize(int readBufferSize)

      Sets the buffer size that will be used to read the data from the file. Changing this value will impact how much the data will be read at a time from the file system.
      Parameters:
        `readBufferSize` - the buffer size
      Returns:
        a reference to this, so the API can be used fluently

    - #### newInstance

          public static AsyncFile newInstance(AsyncFile arg)

Copyright © 2016. All rights reserved.